#!/usr/bin/env node
"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var arg_1 = __importDefault(require("arg"));
var chalk_1 = __importDefault(require("chalk"));
var figlet_1 = __importDefault(require("figlet"));
var fs_1 = __importDefault(require("fs"));
var glob_1 = __importDefault(require("glob"));
var inquirer_1 = __importDefault(require("inquirer"));
var os_1 = __importDefault(require("os"));
var path_1 = __importDefault(require("path"));
var execute_csproj_web_1 = require("./execute-csproj-web");
var uuid_1 = require("uuid");
var execute_node_1 = require("./execute-node");
var project_type_1 = require("./project-type");
var execute_csproj_console_1 = require("./execute-csproj-console");
var execute_csproj_winservice_1 = require("./execute-csproj-winservice");
function execute() {
    return __awaiter(this, void 0, void 0, function () {
        var options, projectType, e_1, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    console.clear();
                    printLogo();
                    options = parseArguments();
                    return [4 /*yield*/, promptForMissingOptions(options)];
                case 1:
                    options = _b.sent();
                    _b.label = 2;
                case 2:
                    _b.trys.push([2, 4, , 5]);
                    return [4 /*yield*/, getProjectType(options.sourceFolder)];
                case 3:
                    projectType = _b.sent();
                    return [3 /*break*/, 5];
                case 4:
                    e_1 = _b.sent();
                    console.log();
                    console.error(e_1);
                    process.exit(1);
                    return [3 /*break*/, 5];
                case 5:
                    console.clear();
                    printLogo();
                    console.log("" + chalk_1.default.bold("Sorgenti"));
                    console.log(chalk_1.default.white("Directory sorgenti:") + "\t\t" + chalk_1.default.grey(options.sourceFolder));
                    console.log(chalk_1.default.white("Tipo di prgetto:") + "\t\t" + chalk_1.default.grey(projectType));
                    console.log();
                    console.log("" + chalk_1.default.bold("Outputs"));
                    console.log(chalk_1.default.white("Directory temporanea:") + "\t\t" + chalk_1.default.grey(options.tempFolder));
                    console.log(chalk_1.default.white("Artefatto S3:") + "\t\t\t" + chalk_1.default.grey(options.s3Artifact));
                    console.log();
                    _a = projectType;
                    switch (_a) {
                        case project_type_1.ProjectType.CSPROJ_CONSOLE: return [3 /*break*/, 6];
                        case project_type_1.ProjectType.CSPROJ_WEB: return [3 /*break*/, 8];
                        case project_type_1.ProjectType.NODE: return [3 /*break*/, 10];
                        case project_type_1.ProjectType.CSPROJ_WINSERVICE: return [3 /*break*/, 12];
                    }
                    return [3 /*break*/, 14];
                case 6: return [4 /*yield*/, execute_csproj_console_1.CsprojConsole.execute(options)];
                case 7:
                    _b.sent();
                    return [3 /*break*/, 15];
                case 8: return [4 /*yield*/, execute_csproj_web_1.CsprojWeb.execute(options)];
                case 9:
                    _b.sent();
                    return [3 /*break*/, 15];
                case 10: return [4 /*yield*/, execute_node_1.Node.execute(options)];
                case 11:
                    _b.sent();
                    return [3 /*break*/, 15];
                case 12: return [4 /*yield*/, execute_csproj_winservice_1.CsprojWinService.execute(options)];
                case 13:
                    _b.sent();
                    return [3 /*break*/, 15];
                case 14: throw new Error("Errore. Il tipo di progetto: " + projectType + " non \u00E8 gestito");
                case 15: return [2 /*return*/];
            }
        });
    });
}
function getAwsCliProfiles() {
    return __awaiter(this, void 0, void 0, function () {
        var awsCliProfileFile, awsCliProfileFileContent, pattern, profiles, match;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    awsCliProfileFile = path_1.default.join(os_1.default.homedir(), ".aws", "credentials");
                    return [4 /*yield*/, fs_1.default.promises.readFile(awsCliProfileFile, "utf8")];
                case 1:
                    awsCliProfileFileContent = _a.sent();
                    pattern = /\[(.*?)\]/g;
                    profiles = [];
                    do {
                        match = pattern.exec(awsCliProfileFileContent);
                        if (match) {
                            profiles.push(match[1]);
                        }
                    } while (match);
                    return [2 /*return*/, profiles];
            }
        });
    });
}
function parseArguments() {
    var args = arg_1.default({
        '--source-folder': String,
        "--temp-folder": String,
        "--s3-artifact": String,
        "--profile": String,
        '-s': '--source',
        "-t": "--temp-folder",
        "-a": "--s3-artifact",
        "-p": "--profile"
    });
    return {
        sourceFolder: args['--source-folder'],
        tempFolder: args["--temp-folder"],
        s3Artifact: args["--s3-artifact"],
        awsCliProfile: args["--profile"]
    };
}
;
function printLogo() {
    console.log(figlet_1.default.textSync('CodePipeline Trigger', {
        font: 'Small',
        horizontalLayout: 'default',
        verticalLayout: 'default'
    }));
    console.log();
}
function promptForMissingOptions(options) {
    var _a, _b, _c;
    return __awaiter(this, void 0, void 0, function () {
        var questions, _d, _e, _f, projectFolder, answers, tempFolder;
        return __generator(this, function (_g) {
            switch (_g.label) {
                case 0:
                    questions = [];
                    if (options.sourceFolder == null) {
                        questions.push({
                            type: "input",
                            name: "sourceFolder",
                            message: "Percorso directory sorgente",
                            default: null,
                        });
                    }
                    if (options.s3Artifact == null) {
                        questions.push({
                            type: "input",
                            name: "s3Artifact",
                            message: "Percorso artefatto da caricare su S3"
                        });
                    }
                    if (!(options.awsCliProfile == null)) return [3 /*break*/, 2];
                    _e = (_d = questions).push;
                    _f = {
                        type: "list",
                        name: "awsCliProfile",
                        message: "Profilo della cli di AWS"
                    };
                    return [4 /*yield*/, getAwsCliProfiles()];
                case 1:
                    _e.apply(_d, [(_f.choices = _g.sent(),
                            _f.default = "default",
                            _f)]);
                    _g.label = 2;
                case 2:
                    projectFolder = (_c = (_b = ((_a = options.sourceFolder) === null || _a === void 0 ? void 0 : _a.match(/([^\/]*)\/*$/)[1])) === null || _b === void 0 ? void 0 : _b.toLowerCase()) !== null && _c !== void 0 ? _c : "";
                    if (options.tempFolder == null) {
                        questions.push({
                            type: "input",
                            name: "tempFolder",
                            message: "Percorso directory temporanea",
                            default: "C:/MYDEV/tmp/deploy/" + projectFolder,
                        });
                    }
                    return [4 /*yield*/, inquirer_1.default.prompt(questions)];
                case 3:
                    answers = _g.sent();
                    tempFolder = options.tempFolder || answers.tempFolder;
                    return [2 /*return*/, __assign(__assign({}, options), { sourceFolder: options.sourceFolder || answers.sourceFolder, tempFolder: tempFolder, s3Artifact: options.s3Artifact || answers.s3Artifact, awsCliProfile: options.awsCliProfile || answers.awsCliProfile, 
                            // Opzioni derivate
                            instanceTempDestinationFolder: path_1.default.join("C:/MYDEV/tmp/", uuid_1.v4()), artifactPath: path_1.default.join(tempFolder, "artifact.zip") })];
            }
        });
    });
}
function getProjectType(sourceFolder) {
    return new Promise(function (resolve, reject) {
        try {
            require(path_1.default.join(sourceFolder, "package.json"));
            return resolve(project_type_1.ProjectType.NODE);
        }
        catch (_a) { }
        glob_1.default("*.csproj", { cwd: sourceFolder }, function (er, files) {
            if (files.length === 1) {
                glob_1.default("web.config", { cwd: sourceFolder }, function (er, files) {
                    if (files.length === 1) {
                        return resolve(project_type_1.ProjectType.CSPROJ_WEB);
                    }
                    else {
                        glob_1.default("winservice.placeholder", { cwd: sourceFolder }, function (er, files) {
                            if (files.length === 1) {
                                return resolve(project_type_1.ProjectType.CSPROJ_WINSERVICE);
                            }
                            else {
                                return resolve(project_type_1.ProjectType.CSPROJ_CONSOLE);
                            }
                        });
                    }
                });
            }
            else {
                return reject("Errore. Nella cartella sorgente " + sourceFolder + " non \u00E8 presente ne package.json ne un file *.csproj");
            }
        });
    });
}
execute();
