"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var archiver_1 = __importDefault(require("archiver"));
var child_process_1 = require("child_process");
var fs_1 = __importDefault(require("fs"));
var listr_1 = __importDefault(require("listr"));
var path_1 = __importDefault(require("path"));
var chalk_1 = __importDefault(require("chalk"));
var execute_commons_1 = require("./execute-commons");
var project_type_1 = require("./project-type");
var mkdirp = require('mkdirp');
var Csproj;
(function (Csproj) {
    function execute(options, projectType) {
        return __awaiter(this, void 0, void 0, function () {
            var publishFolder, publishProfilePath, tasks;
            return __generator(this, function (_a) {
                publishFolder = path_1.default.join(options.tempFolder, "publish");
                publishProfilePath = path_1.default.join(options.tempFolder, "PublishProfile.pubxml");
                console.log("" + chalk_1.default.bold("Tasks"));
                tasks = new listr_1.default([
                    {
                        title: 'Pulizia directory temporanea',
                        task: function () { return execute_commons_1.Commons.clearPreviousPublishFolder(options); }
                    },
                    {
                        title: "Creazione PublishProfile.pubxml",
                        task: function () { return saveVSPublishProfile(publishFolder, publishProfilePath); }
                    },
                    {
                        title: "Build progetto",
                        task: function () { return build(options, publishProfilePath); }
                    },
                    {
                        title: "Creazione files per CodeDeploy",
                        task: function () { return saveCodeDeployFiles(options, publishFolder, projectType); }
                    },
                    {
                        title: "Creazione artefatto (zip)",
                        task: function () { return zip(options, publishFolder); }
                    },
                    {
                        title: "Upload artefatto su S3",
                        task: function () { return execute_commons_1.Commons.uploadToS3(options); }
                    }
                ]);
                tasks.run().catch(function (err) {
                    console.error(err);
                    process.exit(1);
                });
                return [2 /*return*/];
            });
        });
    }
    Csproj.execute = execute;
    function saveVSPublishProfile(publishFolder, publishProfilePath) {
        return __awaiter(this, void 0, void 0, function () {
            var publishProfile, injectedPublishProfile;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fs_1.default.promises.readFile(path_1.default.join(__dirname, "..", "./templates/PublishProfile.pubxml"), "utf8")];
                    case 1:
                        publishProfile = _a.sent();
                        injectedPublishProfile = publishProfile.replace(/_VS_PUBLISH_OUTPUT_FOLDER_/g, publishFolder);
                        return [4 /*yield*/, fs_1.default.promises.writeFile(publishProfilePath, injectedPublishProfile)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
    function saveCodeDeployFiles(options, publishFolder, projectType) {
        return __awaiter(this, void 0, void 0, function () {
            var installFile, files, patterns, _i, files_1, entry, content, _a, patterns_1, p, dest;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        switch (projectType) {
                            case project_type_1.ProjectType.CSPROJ_CONSOLE:
                                installFile = { source: "./templates/csproj-console/install.bat", dest: "install-scripts/install.bat" };
                                break;
                            case project_type_1.ProjectType.CSPROJ_WEB:
                                installFile = { source: "./templates/csproj-web/install.bat", dest: "install-scripts/install.bat" };
                                break;
                            default:
                                throw new Error("invalid project type");
                        }
                        files = [
                            { source: "./templates/appspec.yml", dest: "appspec.yml" },
                            { source: "./templates/before-install.bat", dest: "install-scripts/before-install.bat" },
                            installFile
                        ];
                        patterns = [{
                                key: /_INSTANCE_TEMP_DESTINATION_FOLDER_/g,
                                value: options.instanceTempDestinationFolder
                            }];
                        _i = 0, files_1 = files;
                        _b.label = 1;
                    case 1:
                        if (!(_i < files_1.length)) return [3 /*break*/, 6];
                        entry = files_1[_i];
                        return [4 /*yield*/, fs_1.default.promises.readFile(path_1.default.join(__dirname, "..", entry.source), "utf8")];
                    case 2:
                        content = _b.sent();
                        for (_a = 0, patterns_1 = patterns; _a < patterns_1.length; _a++) {
                            p = patterns_1[_a];
                            content = content.replace(p.key, p.value);
                        }
                        dest = path_1.default.join(publishFolder, entry.dest);
                        return [4 /*yield*/, mkdirp(path_1.default.dirname(dest))];
                    case 3:
                        _b.sent();
                        return [4 /*yield*/, fs_1.default.promises.writeFile(dest, content)];
                    case 4:
                        _b.sent();
                        _b.label = 5;
                    case 5:
                        _i++;
                        return [3 /*break*/, 1];
                    case 6: return [2 /*return*/];
                }
            });
        });
    }
    function build(options, publishProfilePath) {
        return new Promise(function (resolve, reject) {
            var buildCommand = "msbuild " + options.sourceFolder + " /p:DeployOnBuild=true /p:PublishProfile=" + publishProfilePath;
            var buildCommands = buildCommand.split(" ");
            var out = fs_1.default.openSync(path_1.default.join(options.tempFolder, "build.log"), 'a');
            var ex = child_process_1.spawn(buildCommands[0], buildCommands.slice(1, buildCommands.length), {
                stdio: [out, out, out]
            });
            ex.on("error", function (err) {
                console.error("aaa", err);
            });
            ex.on('close', function (code) {
                if (code !== 0)
                    return reject("Exit code " + code + ". Controllare il file build.log");
                else
                    return resolve();
            });
        });
    }
    function zip(options, publishFolder) {
        return __awaiter(this, void 0, void 0, function () {
            var output, archive;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        output = fs_1.default.createWriteStream(options.artifactPath);
                        archive = archiver_1.default('zip');
                        archive.pipe(output);
                        archive.glob("**", {
                            cwd: publishFolder
                        });
                        return [4 /*yield*/, archive.finalize()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
})(Csproj = exports.Csproj || (exports.Csproj = {}));
