"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var archiver_1 = __importDefault(require("archiver"));
var chalk_1 = __importDefault(require("chalk"));
var fs_1 = __importDefault(require("fs"));
var listr_1 = __importDefault(require("listr"));
var path_1 = __importDefault(require("path"));
var execute_commons_1 = require("./execute-commons");
var mkdirp = require('mkdirp');
var Node;
(function (Node) {
    var codeDeployFiles = [
        { source: "./templates/appspec.yml", dest: "appspec.yml" },
        { source: "./templates/before-install.bat", dest: "install-scripts/before-install.bat" },
        { source: "./templates/node/install.bat", dest: "install-scripts/install.bat" }
    ];
    function execute(options) {
        return __awaiter(this, void 0, void 0, function () {
            var tasks;
            return __generator(this, function (_a) {
                console.log("" + chalk_1.default.bold("Tasks"));
                tasks = new listr_1.default([
                    {
                        title: 'Pulizia directory temporanea',
                        task: function () { return execute_commons_1.Commons.clearPreviousPublishFolder(options); }
                    },
                    {
                        title: "Creazione files per CodeDeploy",
                        task: function () { return saveCodeDeployFiles(options); }
                    },
                    {
                        title: "Creazione artefatto (zip)",
                        task: function () { return zip(options); }
                    },
                    {
                        title: "Upload artefatto su S3",
                        task: function () { return execute_commons_1.Commons.uploadToS3(options); }
                    }
                ]);
                tasks.run().catch(function (err) {
                    console.error(err);
                    process.exit(1);
                });
                return [2 /*return*/];
            });
        });
    }
    Node.execute = execute;
    function saveCodeDeployFiles(options) {
        return __awaiter(this, void 0, void 0, function () {
            var patterns, _i, codeDeployFiles_1, entry, content, _a, patterns_1, p, dest;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        patterns = [{
                                key: /_INSTANCE_TEMP_DESTINATION_FOLDER_/g,
                                value: options.instanceTempDestinationFolder
                            }];
                        _i = 0, codeDeployFiles_1 = codeDeployFiles;
                        _b.label = 1;
                    case 1:
                        if (!(_i < codeDeployFiles_1.length)) return [3 /*break*/, 6];
                        entry = codeDeployFiles_1[_i];
                        return [4 /*yield*/, fs_1.default.promises.readFile(path_1.default.join(__dirname, "..", entry.source), "utf8")];
                    case 2:
                        content = _b.sent();
                        for (_a = 0, patterns_1 = patterns; _a < patterns_1.length; _a++) {
                            p = patterns_1[_a];
                            content = content.replace(p.key, p.value);
                        }
                        dest = path_1.default.join(options.tempFolder, entry.dest);
                        return [4 /*yield*/, mkdirp(path_1.default.dirname(dest))];
                    case 3:
                        _b.sent();
                        return [4 /*yield*/, fs_1.default.promises.writeFile(dest, content)];
                    case 4:
                        _b.sent();
                        _b.label = 5;
                    case 5:
                        _i++;
                        return [3 /*break*/, 1];
                    case 6: return [2 /*return*/];
                }
            });
        });
    }
    function zip(options) {
        return __awaiter(this, void 0, void 0, function () {
            var output, archive, _i, codeDeployFiles_2, file;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        output = fs_1.default.createWriteStream(options.artifactPath);
                        archive = archiver_1.default('zip');
                        archive.pipe(output);
                        archive.glob("!(node_modules|build|dist|.vscode)/**", {
                            cwd: options.sourceFolder,
                            dot: true
                        });
                        archive.glob("!(node_modules|build|dist|.vscode)", {
                            cwd: options.sourceFolder,
                            dot: true
                        });
                        for (_i = 0, codeDeployFiles_2 = codeDeployFiles; _i < codeDeployFiles_2.length; _i++) {
                            file = codeDeployFiles_2[_i];
                            archive.file(path_1.default.join(options.tempFolder, file.dest), { name: file.dest });
                        }
                        return [4 /*yield*/, archive.finalize()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
})(Node = exports.Node || (exports.Node = {}));
