@echo off

echo %CD%

SET TEMP_INSTALL_FOLDER=_INSTANCE_TEMP_DESTINATION_FOLDER_
SET INSTANCE_NAME_FILE=C:\MYDEV\codedeploy-instancename

:: Get instance name from file
FOR /F "tokens=* USEBACKQ" %%F IN (`type %INSTANCE_NAME_FILE%`) DO (
    SET INSTANCE_NAME=%%F
)
if "%INSTANCE_NAME%" == "" (
    @echo Error. File %INSTANCE_NAME_FILE% does not exists or is empty
    exit 1
)
@echo INSTANCE_NAME = %INSTANCE_NAME%
@echo DEPLOYMENT_GROUP_NAME = %DEPLOYMENT_GROUP_NAME%
@echo APPLICATION_NAME = %APPLICATION_NAME%


:: Set variables using bucket CONFIG file
@echo on
aws s3 sync s3://%APPLICATION_NAME%/configs/%DEPLOYMENT_GROUP_NAME%/%INSTANCE_NAME% %TEMP_INSTALL_FOLDER% || exit 1
@echo off
for /f "delims=" %%a in (%TEMP_INSTALL_FOLDER%/install.config) do set %%a
@echo TARGET_FOLDER = %TARGET_FOLDER%
@echo WINSERVICE_NAME = %WINSERVICE_NAME%

@echo Starting execution..

:: Disable scheduled task if present
if NOT "%WINSERVICE_NAME%" == "" (
    call :stopTasks "%WINSERVICE_NAME%"
)

:: Sleep 
ping 127.0.0.1 -n 60 > nul

:: Clear all previous file in folder
if exist %TARGET_FOLDER% rmdir %TARGET_FOLDER% /S /Q
@echo Folder %TARGET_FOLDER% cleared


:: Copy all files
xcopy /s %TEMP_INSTALL_FOLDER%. %TARGET_FOLDER% || exit 1


:: Enable scheduled task if present
if NOT "%WINSERVICE_NAME%" == "" (
   call :startTasks "%WINSERVICE_NAME%"
)

:: Trigger task
:: if NOT "%SCHEDULED_TASK_NAME%" == "" (
::    schtasks.exe /Run /TN "%SCHEDULED_TASK_NAME%"  || exit 1
::)


:: Clear all previous file in temp folder
if exist %TEMP_INSTALL_FOLDER% rmdir %TEMP_INSTALL_FOLDER% /S /Q || exit 1
@echo Folder %TEMP_INSTALL_FOLDER% cleared

@echo Execution completed
EXIT /B 0


:stopTasks
setlocal
set list=%1
set list=%list:"=%
FOR /f "tokens=1* delims=," %%a IN ("%list%") DO (
    @echo Stopping windows service %%a
    net stop  "%%a" || exit 1
    if not "%%b" == "" call :stopTasks "%%b"
)
endlocal
EXIT /B 0

:startTasks
setlocal
set list=%1
set list=%list:"=%
FOR /f "tokens=1* delims=," %%a IN ("%list%") DO (
    @echo Starting windows service %%a
    net start "%%a" || exit 1
    if not "%%b" == "" call :startTasks "%%b"
)
endlocal
EXIT /B 0