@echo off

echo %CD%

SET TEMP_INSTALL_FOLDER=_INSTANCE_TEMP_DESTINATION_FOLDER_
SET INSTANCE_NAME_FILE=C:\MYDEV\codedeploy-instancename

:: Get instance name from file
FOR /F "tokens=* USEBACKQ" %%F IN (`type %INSTANCE_NAME_FILE%`) DO (
    SET INSTANCE_NAME=%%F
)
if "%INSTANCE_NAME%" == "" (
    @echo Error. File %INSTANCE_NAME_FILE% does not exists or is empty
    exit 1
)
@echo INSTANCE_NAME = %INSTANCE_NAME%
@echo DEPLOYMENT_GROUP_NAME = %DEPLOYMENT_GROUP_NAME%



:: Set variables using bucket CONFIG file
@echo on
aws s3 sync s3://%APPLICATION_NAME%/configs/%DEPLOYMENT_GROUP_NAME%/%INSTANCE_NAME% %TEMP_INSTALL_FOLDER% || exit 1
@echo off
for /f "delims=" %%a in (%TEMP_INSTALL_FOLDER%/install.config) do set %%a
@echo TARGET_FOLDER = %TARGET_FOLDER%
@echo APP_POOL_NAME = %APP_POOL_NAME%


@echo Starting execution..

:: Stop application pool
C:\Windows\System32\inetsrv\appcmd stop apppool /apppool.name:"%APP_POOL_NAME%" | exit 0
@echo Application pool %APP_POOL_NAME% stopped

:: Clear all previous file in folder
if exist %TARGET_FOLDER% rmdir %TARGET_FOLDER% /S /Q
@echo Folder %TARGET_FOLDER% cleared

:: Copy all files
xcopy /s %TEMP_INSTALL_FOLDER%. %TARGET_FOLDER% || exit 1

:: Start application pool
C:\Windows\System32\inetsrv\appcmd start apppool /apppool.name:"%APP_POOL_NAME%" || exit 1
@echo Application pool %APP_POOL_NAME% started

:: Clear all previous file in temp folder
if exist %TEMP_INSTALL_FOLDER% rmdir %TEMP_INSTALL_FOLDER% /S /Q
@echo Folder %TEMP_INSTALL_FOLDER% cleared

@echo Execution completed